# MCS 275 Spring 2022 Project 2
# David Dumas
# THIS PROGRAM WON'T WORK UNTIL YOU WRITE `intsplit.py`
"Script demonstrating the functions from `intsplit` module"
import time
try:
    import intsplit
except ImportError:
    print("Unable to import intsplit.\nIs this script in the same directory as `intsplit.py`?")
    exit(1)

# First 100 primes
primes100 = [ 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97 ]

def num_splittings_into_primes(n):
    "Return number of ways to split n as a sum of ordered primes"
    if n>100:
        raise ValueError("Only supports n up to 100")
    return len(intsplit.splittings_into(n,primes100))

def num_splittings_into_distinct_primes(n):
    "Return number of ways to split n as a sum of distinct ordered primes"
    if n>100:
        raise ValueError("Only supports n up to 100")
    return len(intsplit.splittings_distinct_into(n,primes100))

def show_splitting_list(L):
    """
    Display a list of splittings nicely, sorting it so all valid solutions
    will produce the same output
    """
    for s in sorted(L,key=lambda s:(-len(s),s),reverse=True):
        print("+".join([str(x) for x in s]))

t0 = time.time()

for func,heading in (intsplit.splittings,"RECURSIVE"), (intsplit.splittings_iterative,"ITERATIVE"), (intsplit.splittings_memoized,"MEMOIZED"):
    print("*"*72)
    print("{:^72s}".format(heading))
    print("*"*72)
    print("Splittings of 3:")
    show_splitting_list(func(3))
    print()
    print("Splittings of 5:")
    show_splitting_list(func(5))
    print()
print("\n"+"*"*72+"\n"+"*"*72+"\n")
print("Total number of splittings:")
for n in range(1,11):
    print("{:3d} {:5d}".format(n,len(intsplit.splittings(n))))
print()
print("Splittings of 7 into parts 2,6,4,3")
show_splitting_list(intsplit.splittings_into(7,[2,6,4,3]))
print()
print("Splittings of 7 into distinct parts")
show_splitting_list(intsplit.splittings_distinct(7))
print()
print("Splittings of 7 into distinct parts from the list 2,6,4,3")
show_splitting_list(intsplit.splittings_distinct_into(7,[2,6,4,3]))
print()
print("Splittings of 5 into at most 3 parts")
show_splitting_list(intsplit.splittings_limited_size(5,3))
print()
print("Number of splittings of n into primes\n")
print("{:>3s} {:>5s} {:>9s}".format("n","all","distinct"))
print("-"*(3+5+9+2))
for n in range(1,21):
    print("{:3d} {:5d} {:9d}".format(
        n,
        num_splittings_into_primes(n),
        num_splittings_into_distinct_primes(n)
    ))

runtime = time.time() - t0
print()
print("Finished in {:.2f} seconds".format(time.time()-t0))
if runtime > 1:
    print("THAT'S UNUSUALLY SLOW. SOMETHING IS PROBABLY WRONG!")